// JavaScript Document

var audioList = [];
var audioCount = 0;
var aListCont = null;
var MAX_REC_TIME = 120000;


function addAppRecorder(){
	var btnGroup = document.createElement("div");
	btnGroup.id = "btnGroup";
	btnGroup.className = "btnGroup";
	btnGroup.style.width = "100%";
	btnGroup.style.marginTop = "8px";
	btnGroup.style.display = "flex";
	btnGroup.style.justifyContent = "space-around";

	var recordTime;

	document.getElementById("recrdPg").appendChild(btnGroup);
	var startR = document.createElement("div");
	startR.id = "startR";
	startR.innerHTML = "Record";
	startR.className = "startR";
	var stopR = document.createElement("div");
	stopR.id = "stopR";
	stopR.innerHTML = "Stop";
	stopR.className = "stopR";
	stopR.classList.add("disableBtn");
	btnGroup.appendChild(startR);
	btnGroup.appendChild(stopR);
	$(startR).on("click", onStartRec);
		
	
	document.getElementById("recrdPg").appendChild(refreshAudioList());
	$(stopR).css({"pointer-evetns":"none"});
	$(startR).css({"pointer-evetns":"auto"});
}

function onStartRec(){
	$(this).off("click");
	app.recordAudio("rspl"+audioCount);
	startR.classList.add("disableBtn");
	stopR.classList.remove("disableBtn");
	recordTime = setTimeout(function(){
		onStopRec();
		clearTimeout(recordTime);		
		alert("Record time limit reched.");
	},MAX_REC_TIME);
	$(startR).css({"pointer-evetns":"none"});
	$(stopR).css({"pointer-evetns":"auto"});
	
	$(stopR).on("click", onStopRec);
}

function onStopRec(){
	$(this).off("click");
	clearTimeout(recordTime);
	app.stopRecord();
	startR.classList.remove("disableBtn");
	stopR.classList.add("disableBtn");
	createAudioList();
	document.getElementById("recrdPg").appendChild(refreshAudioList());
	$(startR).on("click", onStartRec);
}

function cleanup(_cDiv){
	while(_cDiv.hasChildNodes()){
		_cDiv.removeChild(_cDiv.lastChild);
	}	
}

function createAudioList(){
	var obj = new Object();
	obj["pth"] = "rspl"+audioCount;
	obj["id"] = "a"+audioCount;
	obj["val"] = audioCount;
	
	audioList.push(obj);
	localStorage.setItem(audioStorage, JSON.stringify(audioList));
}

function refreshAudioList(){
	var jsonData = JSON.parse(localStorage.getItem(audioStorage));
	audioList = jsonData || audioList;
	
	if(audioList.length){
		var cnt = audioList[audioList.length-1]["val"];
		cnt++;
	}
	audioCount = cnt || 0;
	
	if(aListCont==null)aListCont = document.createElement("div");
	cleanup(aListCont);
	
	for(var i=0; i<audioList.length; i++){
		var audcont = document.createElement("div");
		audcont.setAttribute("id", "audcont");
		audcont.style.width = "100%";
		audcont.style.display = "flex";
		audcont.style.alignItems = "center";
		audcont.style.justifyContent = "space-between";
		audcont.style.marginBottom = "5px";
		
		var delBtn = document.createElement("div");
		delBtn.className = "audDelbtn";
		delBtn.style.width = "25%";
		delBtn.style.padding = "5px";
		delBtn.style.backgroundColor = "#fff";
		delBtn.style.color = "#fb0d0d";
		delBtn.style.fontSize = "25px";
		delBtn.style.marginRight = "2px";
		//delBtn.innerHTML = "Delete";
		delBtn.innerHTML = "&#x2718;";
		delBtn.id = jsonData[i].id;
		delBtn.obj = jsonData[i];
		delBtn.addEventListener("click", ondeleteClicked);
		
		var audDiv = document.createElement("audio");
		audDiv.style.width = "70%";
		/*audDiv.style.webkitTransform = "scale(0.8)";
		audDiv.style.webkitTransformOrigin = "0";*/
		audDiv.controls = true;
		var pre = "file:///storage/emulated/0/"+courseName+"/"
		audDiv.src = pre+jsonData[i].pth+".aac";
		audcont.appendChild(audDiv);
		audcont.appendChild(delBtn);
		
		aListCont.appendChild(audcont);
	}
	var a1 = document.getElementById("iball_record").offsetHeight;
	var a2 = document.getElementById("recordTitle").offsetHeight;
	var a3 = document.getElementById("btnGroup").offsetHeight;
	
	aListCont.setAttribute("id", "aListCont");
	aListCont.style.marginTop = "10px";
	aListCont.style.height = a1 - (a2+a3) - 12 -10 + "px";
	console.log(a1+"---"+a2+"-----"+a3 + "-----FINAL : " + aListCont.style.height);
	aListCont.style.overflow = "auto";
	return aListCont;
}

function ondeleteClicked(e){
	var _obj = e.target.obj;
	
	audioList.splice(audioList.indexOf(_obj), 1);
	console.log("  ",audioList);
	localStorage.setItem(audioStorage, JSON.stringify(audioList));
	refreshAudioList();
	app.deleteAudio(_obj["pth"]);
}